<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <title>Title</title>
  <script>
    let value = "0"
    let changedBy = null

    const numberInput = document.createElement('input')
    const sliderInput = document.createElement('input')
    const components = [numberInput, sliderInput]
    sliderInput.type = "range"

    numberInput.update = () => {
      if (changedBy != null && changedBy !== "numberInput") {
        numberInput.value = value
        changedBy = null
      }
    }
    sliderInput.update = () => {
      if (changedBy != null && changedBy !== "sliderInput") {
        sliderInput.value = value
        changedBy = null
      }
    }

    numberInput.onkeyup     = () => { value = numberInput.value; changedBy = "numberInput" }
    sliderInput.onmousemove = () => { value = sliderInput.value; changedBy = "sliderInput" }

    const update = () => {
      components.forEach(c => c.update())
      window.requestAnimationFrame(update)
    }

    update()

    const onload = () => {
      document.body.append(...components)
    }
  </script>
</head>
<body onload="onload()">
</body>
</html>
